/*
    Copyright (c) 2012,2013 Mirco Attocchi
	
    This file is part of WebAppCommon.

    WebAppCommon is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    WebAppCommon is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with WebAppCommon.  If not, see <http://www.gnu.org/licenses/>.
*/

package it.attocchi.jsf2;

import it.attocchi.jsf2.exceptions.PageAuthException;

import javax.annotation.PostConstruct;

/**
 * Pagina Gestione Utenti Autenticati (Richiede filtro @AuthFilter)
 * 
 * @author Mirco
 * 
 */
public abstract class PageBaseNoAuth extends PageBaseJpa2Data {

	@PostConstruct
	private void postConstruct() {
		try {

			initialiseSession();

			preInit();

			init();

		} catch (Exception ex) {
			logger.error("postConstruct", ex);
			addErrorMessage(ex.getMessage(), ex);
		}
	}

	protected abstract void preInit() throws PageAuthException;

	protected abstract void init() throws Exception;

}
